/*
@C:\WEB_605\SQL\END_CONV\ORACLE\2873_PEDFUNO_IMPOSTO_TITEM_PEDIDO.SQL

 DESCRIO:
 PROCEDURE PARA GERAO DOS IMPOSTOS DE TODOS OS ITENS DO PEDIDO

  PARMETROS

 P_FILIAL      - FILIAL DO PEDIDO
 P_NRPEDIDO    - NUMERO DO PEDIDO

 RAISE_APPLICATION_ERROR(-20501, '' , TRUE);
*/

create or replace PROCEDURE IMPOSTO_TITEM_PEDIDO(
   P_FILIAL     IN FILIAL.CDFILIAL%TYPE,
   P_NRPEDIDO   IN PEDIDO.NRPEDIDO%TYPE)
IS

   V_CDEMPRESA         VARCHAR2(02);
   V_CDINSCESTA        VARCHAR2(16);
   V_CDTIPOOPER        VARCHAR2(02);
   V_IDORIGDESTOP      VARCHAR2(01);
   V_CDCLIENTE         VARCHAR2(21);
   V_CDFILIALPED       VARCHAR2(04);

BEGIN
   SELECT MAX(F.CDEMPRESA), MAX(F.CDINSCESTA), MAX(P.CDTIPOOPER), NVL(MAX(T.IDORIGDESTOP), 'C') IDORIGDESTOP,
          MAX(P.CDCLIENTE), MAX(P.CDFILIALPED)
     INTO V_CDEMPRESA,      V_CDINSCESTA,      V_CDTIPOOPER,      V_IDORIGDESTOP,
          V_CDCLIENTE,      V_CDFILIALPED
     FROM PEDIDO P, TIPOOPERAC T, FILIAL F
    WHERE P.CDFILIAL = P_FILIAL
      AND P.NRPEDIDO = P_NRPEDIDO
      AND P.CDTIPOOPER = T.CDTIPOOPER
      AND P.IDENTRSAIDOP = T.IDENTRSAIDOP
      AND P.CDFILIAL = F.CDFILIAL;

   FOR C_ITENS IN (SELECT P.CDFILIAL,  P.NRPEDIDO, I.NRITEMPED, I.DTENTITPED,
                          P.CDCLIENTE, P.CDFILIALPED, P.CDTIPOOPER, NVL(T.IDORIGDESTOP, 'C') IDORIGDESTOP,
                          F.CDEMPRESA, F.CDINSCESTA, I.QTITEMPED, I.VRPREUNITPED, I.VRDESITPED,
                          I.CDPRODUTO, PR.CDARVPROD
                     FROM PEDIDO P, ITEMPEDIDO I, TIPOOPERAC T, FILIAL F, PRODUTO PR
                    WHERE P.CDFILIAL = P_FILIAL
                      AND P.NRPEDIDO = P_NRPEDIDO
                      AND P.CDFILIAL = I.CDFILIAL
                      AND P.NRPEDIDO = I.NRPEDIDO
                      AND P.CDTIPOOPER = T.CDTIPOOPER
                      AND P.IDENTRSAIDOP = T.IDENTRSAIDOP
                      AND P.CDFILIAL = F.CDFILIAL
                      AND I.CDPRODUTO = PR.CDPRODUTO)
   LOOP


      IMPOSTO_ITEMPEDIDO(C_ITENS.CDEMPRESA, C_ITENS.CDINSCESTA, C_ITENS.CDCLIENTE, C_ITENS.CDFILIALPED,
                         C_ITENS.CDFILIAL,C_ITENS.NRPEDIDO, C_ITENS.NRITEMPED,C_ITENS.DTENTITPED,
                         C_ITENS.CDTIPOOPER, C_ITENS.IDORIGDESTOP);

   END LOOP;

   IMPOSTO_PEDIDO(P_FILIAL, P_NRPEDIDO);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('IMPOSTO_TITEM_PEDIDO','6.05.XXX'); END;
/
